/*===================================================
       OPERAZIONI   SU   MATRICI
====================================================*/

#include "basic_mat.h"


// init
void dmat_init(int m, int n, double ** pt2, double x)
{
  for(int i=0; i<m; i++)  
    for(int j=0; j<n; j++)  pt2[i][j]=x;
}

void imat_init(int m, int n, int ** pt2, int x)
{
  for(int i=0; i<m; i++)  
    for(int j=0; j<n; j++)  pt2[i][j]=x;
}

void cmat_init(int m, int n, char ** pt2, char x)
{
  for(int i=0; i<m; i++)  
    for(int j=0; j<n; j++)  pt2[i][j]=x;
}

// scal
void dmat_scal(int m, int n, double ** pt2, double x)
{
  for( int i=0; i<m; i++)  
    for( int j=0; j<n; j++) pt2[i][j] *= x;
}

//sum
void dmat_sum(int m, int n, 
  double ap, double ** pt2, 
  double aq, double ** qt2)
{
  for(int i=0; i<m; i++) 
    for(int j=0; j<n; j++)  

    pt2[i][j] = aq*qt2[i][j] + ap*pt2[i][j];
}

//Copy
void dmat_cp(int m, int n, double ** pt2, double ** qt2)
{
  for(int i=0; i<m; i++) 
    for(int j=0; j<n; j++) pt2[i][j] = qt2[i][j];
}
/*------------------------------------------------------*/



/*----------------------------------------------
void dmat_init(int m, int n, double * mat, double x)
{
 int i,j;

  for(i=0; i<m; i++)  
    for(j=0; j<n; j++)      mat[i*n+j]=x;
}
-----------------------------------------------
void dmat_scal(int m, int n, double * mat, double x)
{
 int i,j;

  for(i=0; i<m; i++)  
    for(j=0; j<n; j++)      mat[i*n+j] *= x;

}
--------------------------------------------
void dmat_sum(int m, int n, 
  double av, double * v, 
  double au, double * u)
{
  int i,j,k;

  for(i=0; i<m; i++)  
    for(j=0; j<n; j++){
      k = i*n+j;
      v[k] = av*v[k] + au*u[k];
    }
}
--------------------------------------------------
void dmat_cp(int m, int n, double * u, double * v)
{
  int i,j,k;

  for(i=0; i<m; i++)  
    for(j=0; j<n; j++){
      k = i*n+j;
      u[k] = v[k];
    }
}
------------------------------------------------------*/
/****************************************************
    ATTENZIONE: routine per matrici simmetriche
***************************************************/
int dvec_pt2_transl(int n, double ** mat, double * vec)
{

  int c=0;

  for(int i=0; i<n ; i++){
    for(int j=i; j<n ; j++){

      mat[i][j] = mat[j][i] = vec[c];

      c++;
    }
  }

  return c;
}

/*---------------------------------------------------*/

int dpt2_vec_transl(int n, double * vec, double ** mat)
{
  
  int  c = 0;

  for(int i=0; i<n ; i++){
    for(int j=i; j<n ; j++){

      vec[c] = mat[i][j];

      c++;
    }
  }

  return c;
}
/****************************************************
    ATTENZIONE: routine per matrici simmetriche
***************************************************/
int dvec_mat_transl(int n, double * mat, double * vec)
{
  int i,j;
  int k1,k2;
  int c;
  
  c=0;

  for(i=0; i<n ; i++){
    for(j=i; j<n ; j++){
      k1 = i*n+j;
      k2 = j*n+i;
      mat[k1]=mat[k2]=vec[c];
      c++;
    }
  }

  return c;
}
/*---------------------------------------------------*/
int dmat_vec_transl(int n, double * vec, double * mat)
{
  int i,j;
  int k;
  int c;
  
  c=0;

  for(i=0; i<n ; i++){
    for(j=i; j<n ; j++){
      k = i*n+j;
      vec[c]=mat[k];
      c++;
    }
  }
  return c;
}
/*=======================*/
/*VVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVV*/
